// Telegrammer - Telegram Bot Swift SDK.
// This file is autogenerated by API/generate_wrappers.rb script.

/**
 Represents a link to a photo. By default, this photo will be sent by the user with optional caption. Alternatively, you can use input_message_content to send a message with the specified content instead of the photo.

 SeeAlso Telegram Bot API Reference:
 [InlineQueryResultPhoto](https://core.telegram.org/bots/api#inlinequeryresultphoto)
 */
public final class InlineQueryResultPhoto: Codable {

    /// Custom keys for coding/decoding `InlineQueryResultPhoto` struct
    enum CodingKeys: String, CodingKey {
        case type = "type"
        case id = "id"
        case photoUrl = "photo_url"
        case thumbUrl = "thumb_url"
        case photoWidth = "photo_width"
        case photoHeight = "photo_height"
        case title = "title"
        case description = "description"
        case caption = "caption"
        case parseMode = "parse_mode"
        case replyMarkup = "reply_markup"
        case inputMessageContent = "input_message_content"
    }

    /// Type of the result, must be photo
    public var type: String

    /// Unique identifier for this result, 1-64 bytes
    public var id: String

    /// A valid URL of the photo. Photo must be in jpeg format. Photo size must not exceed 5MB
    public var photoUrl: String

    /// URL of the thumbnail for the photo
    public var thumbUrl: String

    /// Optional. Width of the photo
    public var photoWidth: Int?

    /// Optional. Height of the photo
    public var photoHeight: Int?

    /// Optional. Title for the result
    public var title: String?

    /// Optional. Short description of the result
    public var description: String?

    /// Optional. Caption of the photo to be sent, 0-200 characters
    public var caption: String?

    /// Optional. Send Markdown or HTML, if you want Telegram apps to show bold, italic, fixed-width text or inline URLs in the media caption.
    public var parseMode: String?

    /// Optional. Inline keyboard attached to the message
    public var replyMarkup: InlineKeyboardMarkup?

    /// Optional. Content of the message to be sent instead of the photo
    public var inputMessageContent: InputMessageContent?


    public init (type: String, id: String, photoUrl: String, thumbUrl: String, photoWidth: Int? = nil, photoHeight: Int? = nil, title: String? = nil, description: String? = nil, caption: String? = nil, parseMode: String? = nil, replyMarkup: InlineKeyboardMarkup? = nil, inputMessageContent: InputMessageContent? = nil) {
        self.type = type
        self.id = id
        self.photoUrl = photoUrl
        self.thumbUrl = thumbUrl
        self.photoWidth = photoWidth
        self.photoHeight = photoHeight
        self.title = title
        self.description = description
        self.caption = caption
        self.parseMode = parseMode
        self.replyMarkup = replyMarkup
        self.inputMessageContent = inputMessageContent
    }
}
